#FireFly_Form#  Version=3.07
Locked=0
ClientOffset=0
ClientWidth=784
ClientHeight=562


[ControlType] Form | PropertyCount=24 | zorder=1 | tabindex=0 | 
name=FormMain
classstyles=CS_VREDRAW, CS_HREDRAW, CS_DBLCLKS
windowstyles=WS_POPUP, WS_THICKFRAME, WS_CAPTION, WS_SYSMENU, WS_MINIMIZEBOX, WS_MAXIMIZEBOX, WS_CLIPSIBLINGS, WS_CLIPCHILDREN, WS_VISIBLE|WS_EX_WINDOWEDGE, WS_EX_CONTROLPARENT, WS_EX_LEFT, WS_EX_LTRREADING, WS_EX_RIGHTSCROLLBAR
backbitmap=
backbitmapmode=0 - Tiled
backcolor=SYS,15
caption=Zoom Image
export=False
height=600
icon=
left=0
mdichild=False
minwidth=0
minheight=0
maxwidth=0
maxheight=0
startupposition=1 - Centered
tabcontrolchild=False
tabcontrolchildautosize=False
tag=
tag2=
top=0
width=800
windowstate=0 - Normal

[ControlType] CustomControl | PropertyCount=13 | zorder=1 | tabindex=3 | 
name=GDImageZoomControl
windowstyles=|WS_EX_LEFT, WS_EX_LTRREADING
caption=Hubble.jpg
classname=ZIMAGECTRL
font=MS Sans Serif,-11,0,0,0,400,0,0,0,0,1,2,1,34
height=432
left=78
locked=False
resizerules=
tag=
tag2=
top=40
width=628

[ControlType] Slider | PropertyCount=18 | zorder=1 | tabindex=2 | 
name=SlideZoom
windowstyles=WS_CHILD, WS_VISIBLE, WS_TABSTOP, TBS_VERT, TBS_BOTTOM, TBS_AUTOTICKS|
backcolor=SYS,15
controlindex=0
height=432
largechange=1
left=737
locked=False
max=0
min=0
resizerules=0
smallchange=1
tickfrequency=0
tag=
tag2=
top=40
value=195
width=16

[ControlType] CommandButton | PropertyCount=14 | zorder=1 | tabindex=1 | 
name=ImageButtonTemplate
windowstyles=WS_CHILD, BS_PUSHBUTTON, BS_NOTIFY, BS_CENTER, BS_VCENTER|WS_EX_LEFT, WS_EX_LTRREADING
cancel=False
caption=SelectImage.png
controlindex=0
font=MS Sans Serif,-11,0,0,0,400,0,0,0,0,1,2,1,34
height=48
left=72
locked=False
resizerules=
tag=
tag2=
top=488
width=48

[AllCode]

'--------------------------------------------------------------------------------
Function FORMMAIN_WM_CREATE ( _
                            hWndForm As Dword, _      ' handle of Form
                            ByVal UserData As Long _  ' optional user defined Long value
                            ) As Long

    If skInitEngine("Sony.sks", "") Then

       Local hGDImageCtrl, hZoomSlider, hImageButtonTemplate, hImageButton As Dword, imgW, imgH, MaxW, xP, yP, xS, yS As Long, rc As Rect
       Local p As PointApi, zFullpathToImage As Asciiz * %MAX_PATH 

       Call skSkinWindow(hWndForm, "Dock|Undock|Minimize|Maximize|Restore|Close")

'      // Note: Always use the WinLIFT's anchor mode,
'      // because FireFly ResizeRules are limited, and they do not work with the SkinEngine.     
       Call skSetAnchorCtrl(GetDlgItem(hWndForm, IDC_FORMMAIN_SLIDEZOOM), %ANCHOR_HEIGHT_RIGHT)

'      // Compute the good range to use with the zoom slider
       hGDImageCtrl = GetDlgItem(hWndForm, IDC_FORMMAIN_GDIMAGEZOOMCONTROL)
       Call ZI_GetImageSizeFromControl(hGDImageCtrl, imgW, imgH)
       Call GetClientRect(hGDImageCtrl, rc)
       Call ZI_Iconise(imgW, imgH, rc.nRight, rc.nBottom, xP, yP, xS, yS)
       If imgW Then
          MaxW = imgW
          hZoomSlider = GetDlgItem(hWndForm, IDC_FORMMAIN_SLIDEZOOM)
          Call SendMessage(hZoomSlider, %TBM_SETRANGE, 1, Mak(Long, 1, MaxW))
          Call SendMessage(hZoomSlider, %TBM_SETPOS, 1, xS)
       End If     

'      // Create the WinLIFT ImageButton, based on the hidden IMAGEBUTTONTEMPLATE.        
       hImageButtonTemplate = GetDlgItem(hWndForm, IDC_FORMMAIN_IMAGEBUTTONTEMPLATE)
       Call GetWindowRect(hImageButtonTemplate, rc): p.X = rc.nLeft: p.Y = rc.nTop: Call ScreenToClient(hWndForm, p)
       Call GetWindowText(hImageButtonTemplate, zFullpathToImage, SizeOf(zFullpathToImage))
       If Len(zFullpathToImage) Then  
          If Instr(-1, zFullpathToImage, "\") = 0 Then 
             zFullpathToImage = Exe.Path$ + zFullpathToImage 
          End If
'         // We don't need it anymore
          Call DestroyWindow(GetDlgItem(hWndForm, IDC_FORMMAIN_IMAGEBUTTONTEMPLATE))
          hImageButton = skButtonImage(hWndForm, zFullpathToImage, p.X, p.Y, IDC_FORMMAIN_IMAGEBUTTONTEMPLATE, 0)
'         // Anchor the buttom to bottom left.            
          Call skSetAnchorCtrl(hImageButton, %ANCHOR_BOTTOM)
       End If

'      // Add a skinned border around the GDImage control.         
       Call GetWindowRect(hGDImageCtrl, rc)
       p.X = rc.nLeft: p.Y = rc.nTop
       Call ScreenToClient(hWndForm, p)
       Call skBorder(hGDImageCtrl, p.X - 1, p.Y - 1, rc.nRight - rc.nLeft + 2, rc.nBottom - rc.nTop + 2, 0, 1)
       
    End If 

End Function


'--------------------------------------------------------------------------------
Function FORMMAIN_WM_COMMAND ( _
                             hWndForm     As Dword, _  ' handle of Form
                             hWndControl  As Dword, _  ' handle of Control
                             wNotifyCode  As Long,  _  ' notification code
                             wID          As Long   _  ' item, control, or accelerator identifer
                             ) As Long

End Function



'--------------------------------------------------------------------------------
Function FORMMAIN_GDIMAGEZOOMCONTROL_INIT ( _
                                          ClassName   As Asciiz, _  ' windows class
                                          Caption     As Asciiz, _  ' window caption
                                          hWndParent  As Dword,  _  ' handle of parent window
                                          ExStyles    As Dword,  _  ' extended window styles
                                          Styles      As Dword,  _  ' standard window styles
                                          nLeft       As Dword,  _  ' left position of control
                                          nTop        As Dword,  _  ' top position of control
                                          nWidth      As Dword,  _  ' width of control
                                          nHeight     As Dword   _  ' height of control
                                          ) As Long
   ' If your custom control uses CreateWindowEx then use the template below, otherwise
   ' follow the instructions provided by the Custom Control's author. The Custom Control
   ' INIT function is called during the %WM_CREATE message for the Form on which the
   ' Custom Control is created.
  
   Local hGDImageCtrl As Dword

   Local zFullpathToImage As Asciiz * %MAX_PATH

   If RegisterGDImageClass() Then
      If Len(Caption) Then  
         If Instr(-1, Caption, "\") = 0 Then 
            zFullpathToImage = Exe.Path$ + Caption 
         End If
      End If
      hGDImageCtrl = CreateWindowEx(ExStyles, _         ' 0
                                    ClassName, _        ' "ZIMAGECTRL"
                                    zFullpathToImage, _ ' Full path to default image background or ""
                                    %WS_CHILD Or %WS_VISIBLE Or %WS_HSCROLL Or %WS_VSCROLL, _
                                    nLeft, nTop, nWidth, nHeight, _ 
                                    hWndParent, IDC_FORMMAIN_GDIMAGEZOOMCONTROL, _
                                    GetModuleHandle(""), _
                                    ByVal %Null)
                              
      If hGDImageCtrl Then
         Call ZI_SetProperty(hGDImageCtrl, %ZI_ZoomWindow, 1)
         Call ZI_SetAnchorMode(hGDImageCtrl, %ANCHOR_HEIGHT_WIDTH)
      End If         
   End If

   'It is important that this function return the Windows Handle to the newly created Control *** Do not delete this ***.   
   'THAT IS NOT TRUE when using a GDImage control, DO NOT LET FireFly subclass the GDImage control !!!
   'Function = hGDImageCtrl   

End Function


'--------------------------------------------------------------------------------
Function FORMMAIN_SLIDEZOOM_WM_VSCROLL ( _
                                       ControlIndex  As Long,  _  ' index in Control Array
                                       hWndForm      As Dword, _  ' handle of Form
                                       hWndControl   As Dword, _  ' handle of Control
                                       nScrollCode   As Long,  _  ' scroll bar value
                                       nPosition     As Long   _  ' current scroll bar position
                                       ) As Long

    Local hGDImageCtrl As Dword, ZoomValue, OldZoomValue As Single, nPos, imgW, imgH As Long


    hGDImageCtrl = GetDlgItem(hWndForm, IDC_FORMMAIN_GDIMAGEZOOMCONTROL)
    Call ZI_GetImageSizeFromControl(hGDImageCtrl, imgW, imgH)
    nPos = SendMessage(hWndControl, %TBM_GetPos, 0, 0) '// Do not use nPosition, because it could be NULL.
    OldZoomValue = ZI_GetZoomValue(hGDImageCtrl)
    ZoomValue = nPos / ImgW
    If ZoomValue <> OldZoomValue Then
       Call ZI_SetZoomValue(hGDImageCtrl, ZoomValue)
       Call ZI_SetZoomScrollInfo(hGDImageCtrl, OldZoomValue, ZoomValue)
    End If
    Function = -1

End Function



'--------------------------------------------------------------------------------
Function FORMMAIN_IMAGEBUTTONTEMPLATE_BN_CLICKED ( _
                                                 ControlIndex     As Long,  _  ' index in Control Array
                                                 hWndForm         As Dword, _  ' handle of Form
                                                 hWndControl      As Dword, _  ' handle of Control
                                                 idButtonControl  As Long   _  ' identifier of button
                                                 ) As Long
    Local hDW, hGDImageCtrl, hZoomSlider As Dword, MaxW, xP, yP, xS, yS, imgW, imgH As Long, sDataString As String
    Local rc As Rect
    
    hDW = ZI_CreateDW(hWndForm)
    sDataString = ZI_LoadDialog(hWndForm)
    Call ZI_DestroyDW(hDW)
    
    If Len(sDataString) Then

       hGDImageCtrl = GetDlgItem(hWndForm, IDC_FORMMAIN_GDIMAGEZOOMCONTROL)
       Call ZI_SetFromFile(hGDImageCtrl, (sDataString))

'      // Compute the good range to use with the zoom slider
       Call ZI_GetImageSizeFromControl(hGDImageCtrl, imgW, imgH)
       Call GetClientRect(hGDImageCtrl, rc)
       Call ZI_Iconise(imgW, imgH, rc.nRight, rc.nBottom, xP, yP, xS, yS)
       If imgW Then
          MaxW = imgW
          hZoomSlider = GetDlgItem(hWndForm, IDC_FORMMAIN_SLIDEZOOM)
          Call SendMessage(hZoomSlider, %TBM_SETRANGE, 1, Mak(Long, 1, MaxW))
          Call SendMessage(hZoomSlider, %TBM_SETPOS, 1, xS)
       End If     

    End If
End Function

